package java.sql;

import java.time.Instant;
import java.time.LocalDate;

public class Date extends java.util.Date
{
    static final long serialVersionUID = 1511598038487230103L;
    
    @Deprecated
    public Date(int year, int month, int date) {
        super(year, month, date);
    }
    
    public Date(long date) {
        super(date);
    }
    
    @Override
    public void setTime(long time) {
        super.setTime(time);
    }
    
    public static Date valueOf(String s) {
        Date date = null;
        if (s == null) {
            throw new IllegalArgumentException();
        }
        int index = s.indexOf(45);
        int index2 = s.indexOf(45, index + 1);
        if (index > 0 && index2 > 0 && index2 < s.length() - 1) {
            String substring = s.substring(0, index);
            String substring2 = s.substring(index + 1, index2);
            String substring3 = s.substring(index2 + 1);
            if (substring.length() == 4 && substring2.length() >= 1 && substring2.length() <= 2 && substring3.length() >= 1 && substring3.length() <= 2) {
                int int1 = Integer.parseInt(substring);
                int int2 = Integer.parseInt(substring2);
                int int3 = Integer.parseInt(substring3);
                if (int2 >= 1 && int2 <= 12 && int3 >= 1 && int3 <= 31) {
                    date = new Date(int1 - 1900, int2 - 1, int3);
                }
            }
        }
        if (date == null) {
            throw new IllegalArgumentException();
        }
        return date;
    }
    
    @Override
    public String toString() {
        int n = super.getYear() + 1900;
        int n2 = super.getMonth() + 1;
        int date = super.getDate();
        char[] charArray = "2000-00-00".toCharArray();
        charArray[0] = Character.forDigit(n / 1000, 10);
        charArray[1] = Character.forDigit(n / 100 % 10, 10);
        charArray[2] = Character.forDigit(n / 10 % 10, 10);
        charArray[3] = Character.forDigit(n % 10, 10);
        charArray[5] = Character.forDigit(n2 / 10, 10);
        charArray[6] = Character.forDigit(n2 % 10, 10);
        charArray[8] = Character.forDigit(date / 10, 10);
        charArray[9] = Character.forDigit(date % 10, 10);
        return new String(charArray);
    }
    
    @Deprecated
    @Override
    public int getHours() {
        throw new IllegalArgumentException();
    }
    
    @Deprecated
    @Override
    public int getMinutes() {
        throw new IllegalArgumentException();
    }
    
    @Deprecated
    @Override
    public int getSeconds() {
        throw new IllegalArgumentException();
    }
    
    @Deprecated
    @Override
    public void setHours(int n) {
        throw new IllegalArgumentException();
    }
    
    @Deprecated
    @Override
    public void setMinutes(int n) {
        throw new IllegalArgumentException();
    }
    
    @Deprecated
    @Override
    public void setSeconds(int n) {
        throw new IllegalArgumentException();
    }
    
    public static Date valueOf(LocalDate localDate) {
        return new Date(localDate.getYear() - 1900, localDate.getMonthValue() - 1, localDate.getDayOfMonth());
    }
    
    public LocalDate toLocalDate() {
        return LocalDate.of(this.getYear() + 1900, this.getMonth() + 1, this.getDate());
    }
    
    @Override
    public Instant toInstant() {
        throw new UnsupportedOperationException();
    }
}
